var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import L from "leaflet";
L.TileLayer.WMTS = L.TileLayer.extend({
    defaultWmtsParams: {
        service: "WMTS",
        request: "GetTile",
        version: "1.0.0",
        tilematrixSet: "",
        format: "tiles",
        layer: "",
        zoomOffset: 0,
    },
    initialize: function (url, options) {
        this._url = url;
        var wmtsParams = L.extend({}, this.defaultWmtsParams);
        for (var i in options) {
            wmtsParams[i] = options[i];
        }
        options = L.setOptions(this, options);
        var realRetina = options.detectRetina && retina ? 2 : 1;
        var tileSize = this.getTileSize();
        wmtsParams.width = tileSize.x * realRetina;
        wmtsParams.height = tileSize.y * realRetina;
        this.wmtsParams = wmtsParams;
    },
    getTileUrl: function (coords) {
        this.wmtsParams.tileMatrix = this._tileZoom.toString();
        var url = L.Util.template(this._url, { s: this._getSubdomain(coords) });
        var params = __assign(__assign({}, this.wmtsParams), { tileRow: coords.y, tileCol: coords.x });
        return url + L.Util.getParamString(params);
    },
    onAdd: function (map) {
        this._crs = this.options.crs || map.options.crs;
        L.TileLayer.prototype.onAdd.call(this, map);
    },
    setParams: function (params, noRedraw) {
        L.extend(this.wmtsParams, params);
        if (!noRedraw) {
            this.redraw();
        }
        return this;
    },
});
L.tileLayer.wmts = function (url, options) {
    return new L.TileLayer.WMTS(url, options);
};
export default L.tileLayer.wmts;
